<?php
/*
Plugin Name: List Books Feed
Plugin URI: http://www.viewfinderdesign.co.uk/
Description: Retrieves the latest books feed from ListBooks.co.uk and displays in your chosen format
Version: 0.9
Author: Lee Penney
Author URI: http://www.thedigeratipeninsula.org.uk/

copyright (c) 2005 Lee Penney
Released under the terms of the GNU GPL
*/

$path = dirname(__FILE__);
$end = strpos($path,"plugins")-1;
$path = substr($path,0,$end);
define("MY_FILE_PATH", $path . "/");

/* from Amrit Hallan (http://www.developertutorials.com/authors/32) */
function dateDiff($dformat, $endDate, $beginDate) {
  $date_parts1=explode($dformat, $beginDate);
  $date_parts2=explode($dformat, $endDate);
  $start_date=gregoriantojd($date_parts1[0], $date_parts1[1], $date_parts1[2]);
  $end_date=gregoriantojd($date_parts2[0], $date_parts2[1], $date_parts2[2]);
  return $end_date - $start_date;
}

function get_list_books_latest($format) {
  
	$filename = MY_FILE_PATH . "plugins/cache/". 'list_books_latest.html';

	$filedate = @date("m-d-Y", filemtime($filename));
	$curdate = @date("m-d-Y", time());
	$check = dateDiff('-',$curdate,$filedate);

	if (!file_exists($filename) || ($check > 0)) {
	
	switch ($format) {
	  case "none":
	    $leader = "";
			$closer = "";
			$middle = "<br/>";
			$wrap_open = "";
			$wrap_close = "<br/>";
			break;
	  case "list":
	    $leader = "<ul>";
			$closer = "</ul>";
			$middle = "<br/>";
			$wrap_open = "<li>";
			$wrap_close = "</li>";
			break;
		case "ordered":
	    $leader = "<ol>";
			$closer = "</ol>";
			$middle = "<br/>";
			$wrap_open = "<li>";
			$wrap_close = "</li>";
			break;
		case "inline":
	    $leader = "";
			$closer = "";
			$middle = " ";
			$wrap_open = "";
			$wrap_close = ", ";
			break;
		default:
	    $leader = "<ul>";
			$closer = "</ul>";
			$middle = " ";
			$wrap_open = "<li>";
			$wrap_close = "</li>";
			break; 
	}
	
  $url = "http://feeds.feedburner.com/ListBooksLatestListings";
	$filepointer = @fopen($url,"rb");
  if ($filepointer) {
    while(!feof($filepointer)){
      $buffer = @fgets($filepointer, 4096);
      $file .= $buffer;
    }
	}
	else {
		echo "<p><strong>Error:</strong> List Books feed could not be found, either the page was unreachable or they've changed the format.</p>";
	}
  fclose($filepointer);
  $start = strpos($file,'<item>');
	$c = 0;
	while ($c <= 9) {
	  //get the title
	  $start1 = strpos($file,'<title>',$start)+7;
		$end = strpos($file,'</title>',$start1);
		$title = substr($file,$start1,$end-$start1);
		//get the author
		$start1 = strpos($file,'<description>',$start1)+13;
		$end = strpos($file,'</description>',$start1);
		$author = substr($file,$start1,$end-$start1);
		//get the link
		$start1 = strpos($file,'<link>',$start1)+6;
		$end = strpos($file,'</link>',$start1);
		$link = substr($file,$start1,$end-$start1);
		$books[$c] = "<a href=\"$link\" title=\"Link to $title\">".html_entity_decode($title)."</a>".$middle.$author;
		$start = strpos($file,'<item>',$start1);
		$c++;
	}
	
	$text = $leader."\n";
	foreach ($books as $book) {
	  $text .= $wrap_open.$book.$wrap_close."\n";
	}
	$text .= $closer."\n";
	
	$filecreate = @fopen($filename,"w");
  if (fwrite($filecreate,$text) === FALSE) {
    //echo "Cannot write to file ($filename)";
    exit;
  }
    //echo "Success, wrote to file ($csvfile)";
    @fclose($filecreate);
	} else {
	  //echo "Error";
	}
}

function display_list_books_latest($format='list') {
  get_list_books_latest($format);
  $filename = MY_FILE_PATH . "plugins/cache/". 'list_books_latest.html';
  $contents = file($filename);
	foreach ($contents as $lines) {
	  $listings .= $lines;
	}
  echo $listings;
}


?>